<?php
/**
 * layout comments as immutable text
 *
 * @see comments/comments.php
 *
 * @author Bernard Paques [email]bernard.paques@bigfoot.com[/email]
 * @reference
 * @license http://www.gnu.org/copyleft/lesser.txt GNU Lesser General Public License
 */
Class Layout_comments_as_excerpt extends Layout_interface {

	/**
	 * list comments
	 *
	 * @param resource the SQL result
	 * @return string the rendered text
	 *
	 * @see skins/layout.php
	**/
	function &layout(&$result) {
		global $context;

		// empty list
		if(!SQL::count($result)) {
			$output = array();
			return $output;
		}

		// we return an array of ($url => $attributes)
		$items = array();

		// process all items in the list
		include_once $context['path_to_root'].'comments/comments.php';
		while($item =& SQL::fetch($result)) {

			// url to view the comment
			$url = Comments::get_url($item['id']);

			// initialize variables
			$prefix = $label = $suffix = $icon = '';

			// the title as the label
			if($item['create_name'])
				$label .= ucfirst($item['create_name']).' ';

			// time of last update
			$label .= Skin::build_date($item['edit_date']);

			// next line
			$suffix .= BR;

			// cap the number of words
			$suffix .= Skin::cap(Codes::beautify($item['description']), 300);

			// list all components for this item
			$items[$url] = array($prefix, $label, $suffix, 'comment', $icon);

		}

		// end of processing
		SQL::free($result);
		return $items;
	}

}

?>