<?php
/**
 * the index page for letters
 *
 * @author Bernard Paques [email]bernard.paques@bigfoot.com[/email]
 * @author GnapZ
 * @reference
 * @license http://www.gnu.org/copyleft/lesser.txt GNU Lesser General Public License
 */

// common definitions and initial processing
include_once '../shared/global.php';

// root cache id for this page
$root_cache_id = 'letters/index.php';

// render a previous version, if any
Cache::pass_through($root_cache_id);

// load localized strings
i18n::bind('letters');

// load the skin
load_skin('letters');

// the title of the page
$context['page_title'] = i18n::s('Most recent letters');

// menu bar
if(Surfer::is_associate()) {
	$context['page_menu'] = array( 'letters/new.php' => i18n::s('Create a letter') );
	$context['page_menu'] = array_merge($context['page_menu'], array( 'letters/configure.php' => i18n::s('Configure letters') ));
}

// seek the database
include_once $context['path_to_root'].'sections/sections.php';
$anchor = Sections::lookup('letters');
include_once $context['path_to_root'].'articles/articles.php';
if($anchor && ($rows = Articles::list_by_date_for_anchor($anchor, 0, 20)))
	$context['text'] .= Skin::build_list($rows, 'decorated');

// empty list
else
	$context['text'] .= '<p>'.i18n::s('No letter has been sent yet.').'</p>';

// referrals, if any
if(Surfer::is_associate() || (isset($context['with_referrals']) && ($context['with_referrals'] == 'Y'))) {

	$cache_id = 'letters/index.php#referrals#';
	if(!$text =& Cache::get($cache_id)) {

		// box content in a sidebar box
		include_once '../agents/referrals.php';
		if($text = Referrals::list_by_hits_for_url($context['url_to_root_parameter'].'letters/index.php'))
			$text =& Skin::build_box(i18n::s('Referrals'), $text, 'navigation', 'referrals');

		// save in cache for one hour 60 * 60 = 3600
		Cache::put($cache_id, $text, 'referrals', 3600);

	}

	// in the extra panel
	$context['extra'] .= $text;
}

// render the skin
render_skin($root_cache_id);

?>