<?php
/**
 * the privacy disclaimer
 *
 * @link http://www.bebits.com/privacy
 *
 * @author Bernard Paques [email]bernard.paques@bigfoot.com[/email]
 * @tester Moi-meme
 * @reference
 * @license http://www.gnu.org/copyleft/lesser.txt GNU Lesser General Public License
 */

// common definitions and initial processing
include_once 'shared/global.php';

// load localized strings
i18n::bind('root');

// load the skin
load_skin('privacy');

// the title of the page
$context['page_title'] = i18n::s('Privacy Policy');

// splash
$text = i18n::s('<p>We respect your privacy! Any and all information collected at this site will be kept strictly confidential and will not be sold, reused, rented, loaned or otherwise disclosed. Any information you give to us will be held with the utmost care, and will not be used in ways that you have not consented to. Read on for more specific information.</p>')."\n";

// user information
$text .= '[title]'.i18n::s('User Information')."[/title]\n";
$text .= i18n::s('<p>In order to make certain parts of this server work, some sections of the site require you to give us your e-mail address and/or other types of personal information (or may do so in the future). We do not sell, rent, loan, trade, or lease any personal information collected at our site, including survey forms or email lists. In other words, your information is safe with us.</p>')."\n";

// mailings
$text .= '[title]'.i18n::s('Mailings')."[/title]\n";
$text .= '<p>'.i18n::s('<p>In some cases we will use your email address internally, both for identification purposes and to email you updates related to your pages. Your explicit approval is required to mail you our periodic newsletter. At any time you can easily configure your account to enable or to disable such mailings. We <i>may</i>, in certain cases, send you email updates you haven\'t specifically requested to receive; if and when we do this, we won\'t do it without a good reason (and this certainly won\'t serve as our excuse to spam you.)</p>')."</p>\n";

// web logs
$text .= '[title]'.i18n::s('Web Logs')."[/title]\n";
$text .= '<p>'.i18n::s('<p>We occasionally analyzes our website logs to constantly improve the value of the content available on our website. Our website logs are not personally identifiable, and we make no attempt to link them with the individuals that actually browse the site.</p>')."</p>\n";

// cookies
$text .= '[title]'.i18n::s('Cookies')."[/title]\n";
$text .= '<p>'.i18n::s('<p>Although some Internet users think cookies are a serious privacy issue, as web designers we think that they come in darned handy. This site uses cookies for basic account identification purposes, but that\'s as far as we go. We won\'t use any information from cookies to track your browsing sessions, attempt to extract personal information from them that we wouldn\'t otherwise have access to, or do any other naughty things with your cookies. If you don\'t agree with our use of cookies, you can configure most web browsers not to accept them. Even without a cookie, a significant part of this server will still be accessible to you (although you will lose the ability to do anything that requires you to be logged into the server).</p>')."</p>\n";

// passwords
$text .= '[title]'.i18n::s('Passwords')."[/title]\n";
$text .= '<p>'.i18n::s('<p>This server requires you to define and enter passwords to access certain areas of the site. In case this conjures up images of crackers breaking into our databases and getting your passwords, you don\'t have to worry about it. Passwords are stored in an encrypted format, so that <i>we</i> can\'t even look at them. This encryption <i>is</i> breakable, but it takes a lot of effort and computing time (days or weeks to crack a single password) so for all intents and purposes, your passwords are safe here. The downside to this, of course, is that if you lose or forget your password we can\'t get it back for you. We\'ve provided a method to reset your password if this happens, but as with any other password, it\'s best not to forget in the first place.</p>')."</p>\n";

// posted material
$text .= '[title]'.i18n::s('Posted material')."[/title]\n";
$text .= '<p>'.i18n::s('<p>Posted material is, of course, not private; several persons can look at them. But this is as good a time as any to point out that we own and retain control of whatever records you enter into the system. This means that we reserve the right to view and modify your articles, files, links, comments, etc. and we exercise this right. Most of the time we do this to fix trivial things; for example, if you post a page into an incorrect section, made a really obvious typo, or put in something really inappropriate, then we might modify it. But in any case, you should be aware that this could happen. FYI, <i>we</i> get to decide what\'s inappropriate, but you should all know your netiquette by now, right?  :-)</p>')."</p>\n";

// contact
$text .= i18n::s('<hr><p>If you have any questions or comments about our privacy policy, or would like more information about a particular category, please <a href="about.php">get in touch</a> with us.</p>')."\n";

// the date of last modification
if(Surfer::is_associate())
	$context['text'] .= '<p>'.sprintf(i18n::s('Edited %s'), Skin::build_date(getlastmod())).'</p>';

// insert a table of content
$context['text'] .= Codes::beautify("[toc]".$text);

// render the skin
render_skin();

?>